using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using LLNet.Utils;
using LLNet.GUI;

namespace LLNet.Tienda.MainForms.Forms.FacturaElect
{
    public partial class FrmBuscarCliente : Form
    {
        private string vIdentificacion = String.Empty;
        private string vNombre = String.Empty;
        private string vTipo_Identificacion = String.Empty;

        public FrmBuscarCliente()
        {
            InitializeComponent();
        }

        #region Propiedades

        #region mIdentificacion
        /// <summary>
        /// Identificacion
        /// </summary>
        public string mIdentificacion
        {
            get
            {
                return vIdentificacion;
            }
        }
        #endregion

        #region mNombre
        /// <summary>
        /// Nombre del cliente
        /// </summary>
        public string mNombre
        {
            get
            {
                return vNombre;
            }
        }
        #endregion

        #region mTipo_Identificacion
        /// <summary>
        /// Tipo de identificacion
        /// </summary>
        public string mTipo_Identificacion
        {
            get
            {
                return vTipo_Identificacion;
            }
        }
        #endregion

        #endregion

        #region mDatosReceptores
        /// <summary>
        /// Este método busca los datos del receptor, si están, y los muestra
        /// </summary>
        private void mDatosReceptores()
        {
            gcClientes.DataSource = null;
            gcClientes.DataMember = null;

            QueryParams vParametro = new QueryParams();
            vParametro.AddReplaceParam("pTEXTO", txtBusqueda.Text.Replace("-", ""));

            using (DataSet vDatos = CApp.bll.getDataSet("PDV", "FE_V_RECEPTORES_BUSQUEDA", vParametro))
            {
                // Verifica si tiene datos
                if (vDatos.Tables.Count > 0 && vDatos.Tables[0].Rows.Count > 0)
                {
                    gcClientes.DataSource = vDatos;
                    gcClientes.DataMember = vDatos.Tables[0].ToString();
                }
            }
        }
        #endregion

        #region btnAceptar_Click
        private void btnAceptar_Click(object sender, EventArgs e)
        {
            try
            {
                gvClientes_DoubleClick(null, null);

                if (String.IsNullOrEmpty(vIdentificacion))
                {
                    if (CApp.ShowMessage("No ha seleccionado un registro, ¿desea salir de todas formas?", 
                        "Buscar Cliente - Factura Electrónica", true, true) == System.Windows.Forms.DialogResult.Yes)
                    {
                        DialogResult = DialogResult.OK;
                    }
                }
                else
                {
                    DialogResult = DialogResult.OK;
                }
            }
            catch (Exception ex)
            {
                CApp.ShowMessage(ex.Message, "Buscar Cliente - Factura Electrónica", true);
            }
        }
        #endregion

        #region btnSalir_Click
        private void btnSalir_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }
        #endregion

        #region txtBusqueda_KeyDown
        private void txtBusqueda_KeyDown(object sender, KeyEventArgs e)
        {
            try
            {
                if (e.KeyCode == Keys.Enter)
                {
                    mDatosReceptores();
                }
            }
            catch (Exception ex)
            {
                CApp.ShowMessage(ex.Message, "Buscar Cliente - Factura Electrónica", true);
            }
        }
        #endregion

        #region FrmBuscarCliente_Load
        private void FrmBuscarCliente_Load(object sender, EventArgs e)
        {
            try
            {
            }
            catch (Exception ex)
            {
                CApp.ShowMessage(ex.Message, "Buscar Cliente - Factura Electrónica", true);
            }
        }
        #endregion

        #region gvClientes_DoubleClick
        private void gvClientes_DoubleClick(object sender, EventArgs e)
        {
            try
            {
                if (gvClientes.FocusedRowHandle >= 0)
                {
                    vIdentificacion = Convert.ToString(gvClientes.GetRowCellValue(gvClientes.FocusedRowHandle, colIdentificacion));
                    vNombre = Convert.ToString(gvClientes.GetRowCellValue(gvClientes.FocusedRowHandle, colNombre));
                    vTipo_Identificacion = Convert.ToString(gvClientes.GetRowCellValue(gvClientes.FocusedRowHandle, colTipo_Identificacion));
                    //
                    DialogResult = DialogResult.OK;
                }
            }
            catch (Exception ex)
            {
                CApp.ShowMessage(ex.Message, "Buscar Cliente - Factura Electrónica", true);
            }
        }
        #endregion

        private void panelControl3_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}